/*-
 * Copyright (c) 2002-2005 Hye-Shik Chang
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $FreeBSD$
 */

#include <sys/reboot.h>

EXPCONST(int RB_AUTOBOOT)
EXPCONST(int RB_ASKNAME)
EXPCONST(int RB_DFLTROOT)
EXPCONST(int RB_DUMP)
EXPCONST(int RB_HALT)
EXPCONST(int RB_POWEROFF)
EXPCONST(int RB_INITNAME)
EXPCONST(int RB_KDB)
EXPCONST(int RB_NOSYNC)
EXPCONST(int RB_RDONLY)
EXPCONST(int RB_SINGLE)


static char PyFB_reboot__doc__[] =
"reboot([howto]):\n"
"reboots the system.  Only the super-user may reboot a machine on\n"
"demand.  However, a reboot is invoked automatically in the event\n"
"of unrecoverable system failures.";

static PyObject *
PyFB_reboot(PyObject *self, PyObject *args)
{
	int howto = RB_AUTOBOOT;

	if (!PyArg_ParseTuple(args, "|i:reboot", &howto))
		return NULL;

	if (reboot(howto) == -1)
		return OSERROR();

	/* will never reach */
	return NULL;
}
